#!/bin/sh
# Samba-TNG                                          smbpasswd2ldif.sh
# --------------------------------------------------------------------
# Convert SAM-Dump to Smb-importable LDIF-Format

# --------------------------------------------------------------------
. ./prefs
SRC=$1
DST=$2
suffix="$smbsuffix"
# --------------------------------------------------------------------
if [ "$DST" = "" ];then
	echo ""
	echo "usage: $(basename $0) <smbpasswd-input-file> <ldif-output-file>"
	echo ""
	exit
fi
# --------------------------------------------------------------------
echo "Converting <$SRC> to <$DST>..."
# --------------------------------------------------------------------
cat $SRC \
	|sed "s//ss/g" \
	|sed "s//ae/g" \
	|sed "s//oe/g" \
	|sed "s//ue/g" \
	|sed "s//Ae/g" \
	|sed "s//Oe/g" \
	|sed "s//Ue/g" \
	|awk -F: 'BEGIN{
}
{
	uid=$1
	sid=$2
	lmpwd=$3
	ntpwd=$4
	if($5==""){
		cn=uid
	}else{
		cn=$5
	}

	print "dn: uid="uid", "suf
	print "cn: "cn
	print "uid: "uid
	print "ntuid: "uid
	print "lmPassword: "lmpwd
	print "ntPassword: "ntpwd
	if(uid ~ /\$$/){
		print "acctFlags: [W          ]"
	}else{
		print "acctFlags: [UX         ]"
	}
	printf "rid: %x\n",sid
	print "pwdMustChange: ffffffff"
	print "kickoffTime: 7fffffff"
	print "logoffTime: 7fffffff"
	print "objectClass: sambaAccount"
	print "gidNumber: 100"
	print "grouprid: 201"
	print "pwdLastSet: 3982F885"
	print "uidNumber: "sid
	#print "description: "
	print ""
}
END{
}' suf="$suffix"> $DST
# --------------------------------------------------------------------
echo "Done."
# --------------------------------------------------------------------
